Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 3273)
+++ /palm/trunk/SOURCE/header.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -378,9 +381,12 @@
     USE arrays_3d,                                                             &
         ONLY:  pt_init, q_init, s_init, sa_init, ug, vg, w_subs, zu, zw
-        
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  g, kappa, l_v, r_d
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY:  bulk_cloud_model, bcm_header
+
     USE control_parameters
-        
-    USE cloud_parameters,                                                      &
-        ONLY:  cp, l_v, r_d
 
     USE cpulog,                                                                &
@@ -413,9 +419,4 @@
     USE lsf_nudging_mod,                                                       &
         ONLY:  lsf_nudging_header
-
-    USE microphysics_mod,                                                      &
-        ONLY:  cloud_water_sedimentation, collision_turbulence,                &
-               c_sedimentation, limiter_sedimentation, nc_const,               &
-               ventilation_effect
 
     USE model_1d_mod,                                                          &
@@ -742,5 +743,5 @@
     IF ( neutral )  WRITE ( io, 131 )  pt_surface
     IF ( humidity )  THEN
-       IF ( .NOT. cloud_physics )  THEN
+       IF ( .NOT. bulk_cloud_model )  THEN
           WRITE ( io, 129 )
        ELSE
@@ -1902,32 +1903,15 @@
 
 !
-!-- Cloud physics parameters
-    IF ( cloud_physics )  THEN
-       WRITE ( io, 415 )
-       WRITE ( io, 416 ) surface_pressure, r_d, rho_surface, cp, l_v
-       IF ( microphysics_seifert )  THEN
-          WRITE ( io, 510 ) 1.0E-6_wp * nc_const
-          WRITE ( io, 511 ) c_sedimentation
-       ENDIF
-    ENDIF
+!-- Output of microphysics information
+    IF ( bulk_cloud_model )  CALL bcm_header( io )
 
 !
 !-- Cloud physcis parameters / quantities / numerical methods
     WRITE ( io, 430 )
-    IF ( humidity .AND. .NOT. cloud_physics .AND. .NOT. cloud_droplets)  THEN
+    IF ( humidity .AND. .NOT. bulk_cloud_model .AND. .NOT. cloud_droplets)  THEN
        WRITE ( io, 431 )
-    ELSEIF ( humidity  .AND.  cloud_physics )  THEN
-       WRITE ( io, 432 )
-       IF ( cloud_top_radiation )  WRITE ( io, 132 )
-       IF ( microphysics_kessler )  THEN
-          WRITE ( io, 133 )
-       ELSEIF ( microphysics_seifert )  THEN
-          IF ( cloud_water_sedimentation )  WRITE ( io, 506 )
-          WRITE ( io, 505 )
-          IF ( collision_turbulence )  WRITE ( io, 507 )
-          IF ( ventilation_effect )  WRITE ( io, 508 )
-          IF ( limiter_sedimentation )  WRITE ( io, 509 )
-       ENDIF
-    ELSEIF ( humidity  .AND.  cloud_droplets )  THEN
+    ENDIF
+    IF ( cloud_top_radiation )  WRITE ( io, 132 )
+    IF ( humidity  .AND.  cloud_droplets )  THEN
        WRITE ( io, 433 )
        IF ( curvature_solution_effects )  WRITE ( io, 434 )
@@ -2105,5 +2089,4 @@
 132 FORMAT ('     Parameterization of long-wave radiation processes via'/ &
             '     effective emissivity scheme')
-133 FORMAT ('     Precipitation parameterization via Kessler-Scheme')
 134 FORMAT (' --> Additional prognostic equation for a passive scalar')
 135 FORMAT (' --> Solve perturbation pressure via ',A,' method (', &
@@ -2327,11 +2310,4 @@
 413 FORMAT ('       Reference density in buoyancy terms: ',F8.3,' kg/m**3')
 414 FORMAT ('       Reference temperature in buoyancy terms: ',F8.4,' K')
-415 FORMAT (/' Cloud physics parameters:'/ &
-             ' ------------------------'/)
-416 FORMAT ('    Surface pressure   :   p_0   = ',F7.2,' hPa'/      &
-            '    Gas constant       :   R     = ',F5.1,' J/(kg K)'/ &
-            '    Density of air     :   rho_0 =',F6.3,' kg/m**3'/  &
-            '    Specific heat cap. :   c_p   = ',F6.1,' J/(kg K)'/ &
-            '    Vapourization heat :   L_v   =',E9.2,' J/kg')
 420 FORMAT (/'    Characteristic levels of the initial temperature profile:'// &
             '       Height:        ',A,'  m'/ &
@@ -2376,7 +2352,4 @@
               ' ----------------------------------'/)
 431 FORMAT ('    Humidity is considered, bu no condensation')
-432 FORMAT ('    Bulk scheme with liquid water potential temperature and'/ &
-            '    total water content is used.'/ &
-            '    Condensation is parameterized via 0% - or 100% scheme.')
 433 FORMAT ('    Cloud droplets treated explicitly using the Lagrangian part', &
                  'icle model')
@@ -2473,12 +2446,4 @@
 503 FORMAT (' --> Momentum advection via Wicker-Skamarock-Scheme 5th order')
 504 FORMAT (' --> Scalar advection via Wicker-Skamarock-Scheme 5th order')
-505 FORMAT ('    Precipitation parameterization via Seifert-Beheng-Scheme')
-506 FORMAT ('    Cloud water sedimentation parameterization via Stokes law')
-507 FORMAT ('    Turbulence effects on precipitation process')
-508 FORMAT ('    Ventilation effects on evaporation of rain drops')
-509 FORMAT ('    Slope limiter used for sedimentation process')
-510 FORMAT ('    Droplet density    :   N_c   = ',F6.1,' 1/cm**3')
-511 FORMAT ('    Sedimentation Courant number:                  '/&
-            '                               C_s   =',F4.1,'        ')
 512 FORMAT (/' Date:                 ',A8,6X,'Run:       ',A34/      &
             ' Time:                 ',A8,6X,'Run-No.:   ',I2.2/     &
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 3273)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -255,5 +258,5 @@
 ! precipitation_amount, precipitation_rate, prr moved to arrays_3d.
 ! Initialization of nc_1d, nr_1d, pt_1d, qc_1d, qr_1d, q_1d moved to
-! microphysics_init.
+! bcm_init.
 !
 ! 1845 2016-04-08 08:29:13Z raasch
@@ -498,13 +501,14 @@
     USE arrays_3d
 
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  c_p, g, l_v, pi, r_d, exner_function, exner_function_invers,    &
+               ideal_gas_law_rho, ideal_gas_law_rho_pt, barometric_formula
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY:  bulk_cloud_model, bcm_init, bcm_init_arrays
+
     USE chemistry_model_mod,                                                   &
         ONLY:  chem_emissions
 
-    USE cloud_parameters,                                                      &
-        ONLY:  cp, l_v, r_d
-
-    USE constants,                                                             &
-        ONLY:  pi
-    
     USE control_parameters
     
@@ -530,7 +534,4 @@
     USE lsf_nudging_mod,                                                       &
         ONLY:  lsf_init, ls_forcing_surf, nudge_init
-
-    USE microphysics_mod,                                                      &
-        ONLY:  microphysics_init
 
     USE model_1d_mod,                                                          &
@@ -738,72 +739,4 @@
 #endif
 
-       IF ( cloud_physics )  THEN
-!
-!--          Liquid water content
-#if defined( __nopointer )
-          ALLOCATE ( ql(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#else
-          ALLOCATE ( ql_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#endif
-
-!
-!--       3D-cloud water content
-          IF ( .NOT. microphysics_morrison )  THEN
-#if defined( __nopointer )
-             ALLOCATE( qc(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#else
-             ALLOCATE( qc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#endif
-          ENDIF
-!
-!--       Precipitation amount and rate (only needed if output is switched)
-          ALLOCATE( precipitation_amount(nysg:nyng,nxlg:nxrg) )
-
-!
-!--       3d-precipitation rate
-          ALLOCATE( prr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-
-          IF ( microphysics_morrison )  THEN
-!
-!--          3D-cloud drop water content, cloud drop concentration arrays
-#if defined( __nopointer )
-             ALLOCATE( nc(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
-                       nc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       qc(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
-                       qc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       tnc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                   & 
-                       tqc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#else
-             ALLOCATE( nc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       nc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       nc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       qc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       qc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       qc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#endif
-          ENDIF
-
-          IF ( microphysics_seifert )  THEN
-!
-!--          3D-rain water content, rain drop concentration arrays
-#if defined( __nopointer )
-             ALLOCATE( nr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
-                       nr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       qr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
-                       qr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       tnr_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                   &
-                       tqr_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#else
-             ALLOCATE( nr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       nr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       nr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       qr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       qr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                    &
-                       qr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#endif
-          ENDIF
-
-       ENDIF
-
        IF ( cloud_droplets )  THEN
 !
@@ -868,13 +801,13 @@
 !
 !-- Density profile calculation for anelastic approximation
-    t_surface = pt_surface * ( surface_pressure / 1000.0_wp )**( r_d / cp )
+    t_surface = pt_surface * ( surface_pressure / 1000.0_wp )**( r_d / c_p )
     IF ( TRIM( approximation ) == 'anelastic' ) THEN
        DO  k = nzb, nzt+1
           p_hydrostatic(k)    = surface_pressure * 100.0_wp *                  &
-                                ( 1 - ( g * zu(k) ) / ( cp * t_surface )       &
-                                )**( cp / r_d )
+                                ( 1 - ( g * zu(k) ) / ( c_p * t_surface )      &
+                                )**( c_p / r_d )
           rho_air(k)          = ( p_hydrostatic(k) *                           &
                                   ( 100000.0_wp / p_hydrostatic(k)             &
-                                  )**( r_d / cp )                              &
+                                  )**( r_d / c_p )                             &
                                 ) / ( r_d * pt_init(k) )
        ENDDO
@@ -887,9 +820,9 @@
        DO  k = nzb, nzt+1
           p_hydrostatic(k)    = surface_pressure * 100.0_wp *                  &
-                                ( 1 - ( g * zu(nzb) ) / ( cp * t_surface )       &
-                                )**( cp / r_d )
+                                ( 1 - ( g * zu(nzb) ) / ( c_p * t_surface )    &
+                                )**( c_p / r_d )
           rho_air(k)          = ( p_hydrostatic(k) *                           &
                                   ( 100000.0_wp / p_hydrostatic(k)             &
-                                  )**( r_d / cp )                              &
+                                  )**( r_d / c_p )                             &
                                 ) / ( r_d * pt_init(nzb) )
        ENDDO
@@ -923,5 +856,5 @@
             momentumflux_input_conversion(k)  = rho_air_zw(k)
         ELSEIF ( TRIM( flux_input_mode ) == 'dynamic' ) THEN
-            heatflux_input_conversion(k)      = 1.0_wp / cp
+            heatflux_input_conversion(k)      = 1.0_wp / c_p
             waterflux_input_conversion(k)     = 1.0_wp / l_v
             momentumflux_input_conversion(k)  = 1.0_wp
@@ -933,5 +866,5 @@
             momentumflux_output_conversion(k) = drho_air_zw(k)
         ELSEIF ( TRIM( flux_output_mode ) == 'dynamic' ) THEN
-            heatflux_output_conversion(k)     = cp
+            heatflux_output_conversion(k)     = c_p
             waterflux_output_conversion(k)    = l_v
             momentumflux_output_conversion(k) = 1.0_wp
@@ -1065,21 +998,5 @@
     IF ( humidity )  THEN
        q => q_1;  q_p => q_2;  tq_m => q_3
-       IF ( humidity )  THEN
-          vpt  => vpt_1    
-          IF ( cloud_physics )  THEN
-             ql => ql_1
-             IF ( .NOT. microphysics_morrison )  THEN
-                qc => qc_1
-             ENDIF
-             IF ( microphysics_morrison )  THEN
-                qc => qc_1;  qc_p  => qc_2;  tqc_m  => qc_3
-                nc => nc_1;  nc_p  => nc_2;  tnc_m  => nc_3
-             ENDIF
-             IF ( microphysics_seifert )  THEN
-                qr => qr_1;  qr_p  => qr_2;  tqr_m  => qr_3
-                nr => nr_1;  nr_p  => nr_2;  tnr_m  => nr_3
-             ENDIF
-          ENDIF
-       ENDIF
+       vpt  => vpt_1
        IF ( cloud_droplets )  THEN
           ql   => ql_1
@@ -1102,4 +1019,9 @@
 !-- Initialize surface arrays
     CALL init_surface_arrays
+!
+!-- Allocate microphysics module arrays
+    IF ( bulk_cloud_model )  THEN
+       CALL bcm_init_arrays
+    ENDIF
 !
 !-- Allocate land surface model arrays
@@ -1297,26 +1219,4 @@
 !--       Set inital w to 0
           w = 0.0_wp
-!
-!--       Initialize the remaining quantities
-          IF ( humidity )  THEN
-             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      qc(:,j,i) = 0.0_wp
-                      nc(:,j,i) = 0.0_wp
-                   ENDDO
-                ENDDO
-             ENDIF
-
-             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      qr(:,j,i) = 0.0_wp
-                      nr(:,j,i) = 0.0_wp
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          ENDIF
 
           IF ( passive_scalar )  THEN
@@ -1376,20 +1276,4 @@
                 ENDDO
              ENDDO
-             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      qc(:,j,i) = 0.0_wp
-                      nc(:,j,i) = 0.0_wp
-                   ENDDO
-                ENDDO
-             ENDIF
-             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      qr(:,j,i) = 0.0_wp
-                      nr(:,j,i) = 0.0_wp
-                   ENDDO
-                ENDDO
-             ENDIF
           ENDIF
 
@@ -1485,22 +1369,4 @@
                 ENDDO
              ENDDO
-             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      qc(:,j,i) = 0.0_wp
-                      nc(:,j,i) = 0.0_wp
-                   ENDDO
-                ENDDO
-             ENDIF
-
-             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      qr(:,j,i) = 0.0_wp
-                      nr(:,j,i) = 0.0_wp
-                   ENDDO
-                ENDDO
-             ENDIF
-
           ENDIF
           
@@ -1598,5 +1464,5 @@
 !--       Store initial profile of mixing ratio and potential
 !--       temperature
-          IF ( cloud_physics  .OR.  cloud_droplets ) THEN
+          IF ( bulk_cloud_model  .OR.  cloud_droplets ) THEN
              hom(:,1,27,:) = SPREAD(  q(:,nys,nxl), 2, statistic_regions+1 )
              hom(:,1,28,:) = SPREAD( pt(:,nys,nxl), 2, statistic_regions+1 )
@@ -1645,14 +1511,4 @@
 !--    In case of iterative solvers, p must get an initial value
        IF ( psolver(1:9) == 'multigrid'  .OR.  psolver == 'sor' )  p = 0.0_wp
-
-!
-!--    Treating cloud physics, liquid water content and precipitation amount
-!--    are zero at beginning of the simulation
-       IF ( cloud_physics )  THEN
-          ql = 0.0_wp
-          qc = 0.0_wp
-
-          precipitation_amount = 0.0_wp
-       ENDIF
 !
 !--    Impose vortex with vertical axis on the initial velocity profile
@@ -1693,16 +1549,4 @@
           tq_m = 0.0_wp
           q_p = q
-          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
-             tqc_m = 0.0_wp
-             qc_p  = qc
-             tnc_m = 0.0_wp
-             nc_p  = nc
-          ENDIF
-          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-             tqr_m = 0.0_wp
-             qr_p  = qr
-             tnr_m = 0.0_wp
-             nr_p  = nr
-          ENDIF
        ENDIF
        
@@ -1963,12 +1807,4 @@
        IF ( humidity )  THEN
           q_p = q
-          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
-             qc_p = qc
-             nc_p = nc
-          ENDIF
-          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-             qr_p = qr
-             nr_p = nr
-          ENDIF
        ENDIF
        IF ( passive_scalar )  s_p  = s
@@ -1982,12 +1818,4 @@
        IF ( humidity )  THEN
           tq_m = 0.0_wp
-          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
-             tqc_m = 0.0_wp
-             tnc_m = 0.0_wp
-          ENDIF
-          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-             tqr_m = 0.0_wp
-             tnr_m = 0.0_wp
-          ENDIF
        ENDIF
        IF ( passive_scalar )  ts_m  = 0.0_wp
@@ -2417,14 +2245,41 @@
        CALL init_ocean
 
-    ELSE
+    ENDIF
 !
 !--    Initialize quantities for handling cloud physics
 !--    This routine must be called before lpm_init, because
-!--    otherwise, array pt_d_t, needed in data_output_dvrp (called by
+!--    otherwise, array d_exner, needed in data_output_dvrp (called by
 !--    lpm_init) is not defined.
-       CALL init_cloud_physics
-!
-!--    Initialize bulk cloud microphysics
-       CALL microphysics_init
+    IF ( .NOT. ocean )  THEN
+
+       ALLOCATE( hyp(nzb:nzt+1) )
+       ALLOCATE( d_exner(nzb:nzt+1) )
+       ALLOCATE( exner(nzb:nzt+1) )
+       ALLOCATE( hyrho(nzb:nzt+1) )
+!
+!--    Check temperature in case of too large domain height
+       DO  k = nzb, nzt+1
+          IF ( ( pt_surface * exner_function(surface_pressure * 100.0_wp) - g/c_p * zu(k) ) < 0.0_wp )  THEN
+             WRITE( message_string, * )  'absolute temperature < 0.0 at zu(', k, &
+                                         ') = ', zu(k)
+             CALL message( 'init_bulk_cloud_model', 'PA0142', 1, 2, 0, 6, 0 )
+          ENDIF
+       ENDDO
+
+!
+!--    Calculate vertical profile of the hydrostatic pressure (hyp)
+       hyp    = barometric_formula(zu, pt_surface * exner_function(surface_pressure * 100.0_wp), surface_pressure * 100.0_wp)
+       d_exner = exner_function_invers(hyp)
+       exner = 1.0_wp / exner_function_invers(hyp)
+       hyrho  = ideal_gas_law_rho_pt(hyp, pt_init)
+!
+!--    Compute reference density
+       rho_surface = ideal_gas_law_rho(surface_pressure * 100.0_wp, pt_surface * exner_function(surface_pressure * 100.0_wp))
+
+    ENDIF
+!
+!-- If required, initialize quantities needed for the microphysics module
+    IF ( bulk_cloud_model )  THEN
+       CALL bcm_init
     ENDIF
 
Index: /palm/trunk/SOURCE/init_masks.f90
===================================================================
--- /palm/trunk/SOURCE/init_masks.f90	(revision 3273)
+++ /palm/trunk/SOURCE/init_masks.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3065 2018-06-12 07:03:02Z Giersch
 ! dz_stretch_level was replaced by dz_stretch_level_start
 ! 
@@ -134,5 +137,5 @@
 
     USE control_parameters,                                                    &
-        ONLY:  constant_diffusion, cloud_droplets, cloud_physics,              &
+        ONLY:  constant_diffusion, cloud_droplets,                             &
                data_output_masks, data_output_masks_user,                      &
                doav, doav_n, domask, domask_no, dz, dz_stretch_level_start,    &
@@ -142,7 +145,6 @@
                mask_x_loop, mask_xyz_dimension, mask_y, mask_y_loop, mask_z,   &
                mask_z_loop, max_masks,  message_string, mid,                   &
-               microphysics_morrison, microphysics_seifert, passive_scalar,    &
-               ocean, varnamelength
-               
+               passive_scalar, ocean, varnamelength
+
 
     USE grid_variables,                                                        &
@@ -153,4 +155,7 @@
 
     USE kinds
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
 
     USE netcdf_interface,                                                      &
@@ -309,7 +314,7 @@
 
              CASE ( 'lpt' )
-                IF ( .NOT. cloud_physics )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
-                        '" requires cloud_physics = .TRUE.'
+                IF ( .NOT. bulk_cloud_model )  THEN
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
+                        '" requires bulk_cloud_model = .TRUE.'
                    CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
                 ENDIF
@@ -317,7 +322,7 @@
 
              CASE ( 'nc' )
-                IF ( .NOT. cloud_physics )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
-                        '" requires cloud_physics = .TRUE.'
+                IF ( .NOT. bulk_cloud_model )  THEN
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
+                        '" requires bulk_cloud_model = .TRUE.'
                    CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
                  ELSEIF ( .NOT. microphysics_morrison ) THEN
@@ -329,7 +334,7 @@
 
              CASE ( 'nr' )
-                IF ( .NOT. cloud_physics )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
-                        '" requires cloud_physics = .TRUE.'
+                IF ( .NOT. bulk_cloud_model )  THEN
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
+                        '" requires bulk_cloud_model = .TRUE.'
                    CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
                  ELSEIF ( .NOT. microphysics_seifert ) THEN
@@ -360,7 +365,7 @@
 
              CASE ( 'qc' )
-                IF ( .NOT. cloud_physics )  THEN
+                IF ( .NOT. bulk_cloud_model )  THEN
                    message_string = 'output of "' // TRIM( var ) // '"' //     &
-                            'requires cloud_physics = .TRUE.'
+                            'requires bulk_cloud_model = .TRUE.'
                    CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
                 ENDIF
@@ -368,8 +373,8 @@
 
              CASE ( 'ql' )
-                IF ( .NOT. ( cloud_physics  .OR.  cloud_droplets ) )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
-                        '" requires cloud_physics = .TRUE. or cloud_droplets', &
-                        ' = .TRUE.'
+                IF ( .NOT. ( bulk_cloud_model  .OR.  cloud_droplets ) )  THEN
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
+                        '" requires bulk_cloud_model = .TRUE. or ',            &
+                        'cloud_droplets = .TRUE.'
                    CALL message( 'init_masks', 'PA0106', 1, 2, 0, 6, 0 )
                 ENDIF
@@ -387,7 +392,7 @@
 
              CASE ( 'qv' )
-                IF ( .NOT. cloud_physics )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
-                        '" requires cloud_physics = .TRUE.'
+                IF ( .NOT. bulk_cloud_model )  THEN
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
+                        '" requires bulk_cloud_model = .TRUE.'
                    CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
                 ENDIF
@@ -395,7 +400,7 @@
 
              CASE ( 'qr' )
-                IF ( .NOT. cloud_physics )  THEN
+                IF ( .NOT. bulk_cloud_model )  THEN
                    message_string = 'output of "' // TRIM( var ) // '" ' //    &
-                            'requires cloud_physics = .TRUE.'
+                            'requires bulk_cloud_model = .TRUE.'
                    CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
                 ELSEIF ( .NOT. microphysics_seifert ) THEN
Index: /palm/trunk/SOURCE/init_ocean.f90
===================================================================
--- /palm/trunk/SOURCE/init_ocean.f90	(revision 3273)
+++ /palm/trunk/SOURCE/init_ocean.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! ------------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3270 2018-09-24 06:28:20Z raasch
 ! bugfix for r2502: wrong calculation of hyp(nzt) in second iterative step
 ! 
@@ -90,6 +93,9 @@
         ONLY:  dzu, hyp, pt_init, ref_state, sa_init, zu, zw
 
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  g
+
     USE control_parameters,                                                    &
-        ONLY:  g, molecular_viscosity, prho_reference, rho_surface,            &
+        ONLY:  molecular_viscosity, prho_reference, rho_surface,               &
                rho_reference, surface_pressure, use_single_reference_value
 
Index: /palm/trunk/SOURCE/init_rankine.f90
===================================================================
--- /palm/trunk/SOURCE/init_rankine.f90	(revision 3273)
+++ /palm/trunk/SOURCE/init_rankine.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -73,5 +76,5 @@
         ONLY:  initializing_actions, n_sor, nsor, nsor_ini   
 
-    USE constants,                                                             &
+    USE basic_constants_and_equations_mod,                                     &
         ONLY:  pi
 
Index: /palm/trunk/SOURCE/init_slope.f90
===================================================================
--- /palm/trunk/SOURCE/init_slope.f90	(revision 3273)
+++ /palm/trunk/SOURCE/init_slope.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -72,5 +75,5 @@
         ONLY:  pt, pt_init, pt_slope_ref, zu
         
-    USE constants,                                                             &
+    USE basic_constants_and_equations_mod,                                     &
         ONLY:  pi
                     
Index: /palm/trunk/SOURCE/interaction_droplets_ptq.f90
===================================================================
--- /palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 3273)
+++ /palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3040 2018-05-25 10:22:08Z schwenkel
 ! Changed the name specific humidity to mixing ratio
 ! 
@@ -74,5 +77,5 @@
 !
 ! 799 2011-12-21 17:48:03Z franke
-! Bugfix: pt_d_t(k) was missing in calculation of pt_p
+! Bugfix: d_exner(k) was missing in calculation of pt_p
 !
 ! RCS Log replace by Id keyword, revision history cleaned up
@@ -89,4 +92,17 @@
  MODULE interaction_droplets_ptq_mod
  
+
+    USE arrays_3d,                                                             &
+        ONLY:  pt_p, ql_c, q_p, d_exner
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  lv_d_cp
+
+    USE indices,                                                               &
+        ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
+
+    USE kinds
+
+    USE pegrid
 
     PRIVATE
@@ -111,17 +127,4 @@
     SUBROUTINE i_droplets_ptq
 
-       USE arrays_3d,                                                          &
-           ONLY:  pt_p, ql_c, q_p
-           
-       USE cloud_parameters,                                                   &
-           ONLY:  l_d_cp, pt_d_t
-           
-       USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
-           
-       USE kinds
-
-       USE pegrid
-
        IMPLICIT NONE
 
@@ -140,5 +143,5 @@
 
                 q_p(k,j,i)  = q_p(k,j,i)  - ql_c(k,j,i) * flag
-                pt_p(k,j,i) = pt_p(k,j,i) + l_d_cp * ql_c(k,j,i) * pt_d_t(k)   &
+                pt_p(k,j,i) = pt_p(k,j,i) + lv_d_cp * ql_c(k,j,i) * d_exner(k) &
                                                         * flag
              ENDDO
@@ -155,18 +158,4 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE i_droplets_ptq_ij( i, j )
-
-       USE arrays_3d,                                                          &
-           ONLY:  pt_p, ql_c, q_p
-
-       USE cloud_parameters,                                                   &
-           ONLY:  l_d_cp, pt_d_t
-
-       USE indices,                                                            &
-           ONLY:  nzb, nzt, wall_flags_0
-
-       USE kinds,                                                              &
-           ONLY:  iwp, wp
-
-       USE pegrid
 
        IMPLICIT NONE
@@ -185,5 +174,5 @@
 
           q_p(k,j,i)  = q_p(k,j,i)  - ql_c(k,j,i) * flag
-          pt_p(k,j,i) = pt_p(k,j,i) + l_d_cp * ql_c(k,j,i) * pt_d_t(k) * flag
+          pt_p(k,j,i) = pt_p(k,j,i) + lv_d_cp * ql_c(k,j,i) * d_exner(k) * flag
        ENDDO
 
